<?php
defined('WEKIT_VERSION') or exit(403);

define('ERROR_INVALID_PWD', 1403);
define('ERROR_REQUERIY_FIELD', 1404);
define('ERROR_PARA', 1405);
define('ERROR_SYSTEM', 1500);

Wind::import('SRV:user.vo.PwUserSo');
Wind::import('SRV:user.dao.PwUserBelongDao');

class keydatas_util {

    public $value = array();

    public function __construct() {
        ;
    }



    protected function randEmail($username) {
        $emailSps = array('163.com', '139.com','qq.com', 'sina.com');
        $f = substr(md5($username),8,rand(6, 12));
        return $f . '@' . $emailSps[rand(0, 6)];
    }
 

    protected function isToday($timestemp) {
        if (date("Y-m-d",time()) === date("Y-m-d", intval($timestemp))) {
            return true;
        }
        return false;
    }


	
	/**
	 * õip
	 */
	protected function randomip()
	{
		return rand(0,255).'.'.rand(0,255).'.'.rand(0,255).'.'.rand(0,255);
	}




    public static function getConfigKeys() {
        return array(
            'use_authors',
            'use_topics',
            'use_avatars',
            'use_pubtime',
            'use_comments',
            'min_time',
            'default_password',
            'default_forum',
            'isDebug',
            'custome_category_config',
            'custome_category'
        );
    }


    protected function _getFroumService() {
        return Wekit::load('forum.srv.PwForumService');
    }

    protected function getFroums() {
        $forumService = $this->_getFroumService();
        $map = $forumService->getForumMap();
        $catedb = $map[0];
        $detail = array();

        foreach ($catedb as $key => $value) {
            $forumList[$value['fid']] = $forumService->getForumsByLevel($value['fid'], $map);
        }

        foreach ($map[0] as $forum) {
            $detail[] = array('value' => $forum['fid'], 'text' => urlencode($forum['name']));
            if (isset($forumList[$forum['fid']])) {
                foreach ($forumList[$forum['fid']] as $k => $v) {
                    $detail[] = array('value' => $v['fid'], 'text' => urlencode($v['name'] . '(' . $v['fupname'] . ')'));
                }
            }
        }

        return $detail;
    }
	
	
    public function getUsername($username) {
        $md5author = substr(md5($username), 8, 13);
        return $md5author;
    }

    public function getMember($username) {
        $uid = '';
        try {
            $vo = new PwUserSo();
            $searchDs = Wekit::load('user.PwUserSearch');
			$vo->setUsername($this->getUsername($username));
			$result = $searchDs->searchUserAllData($vo, 1, 0);
			if (count($result)) {
				foreach ($result as $user) {
					$uid = $user['uid'];
				}
			}
        } catch (\Exception $exc) {
            throw $exc;
        }

        if (!$uid) {
            try {
                $user = $this->insertMember($username);
            } catch (\Exception $exc) {
                throw $exc;
            }
        }
        return $user;
    }

    protected function initPassword() {
        $pw = '888888';
        return $pw;
    }
	
    protected function randTime($min = '', $max = '') {
        if (!$max) {
            $max = time();
        }

        return rand($min, $max);
    }
	
    public function insertMember($username) {

        $email = $this->randEmail($username);

        $md5author = $this->getUsername($username);
        $uid = 0;

        try {
            Wind::import('SRC:service.user.dm.PwUserInfoDm');
            $dm = new PwUserInfoDm();
            $dm->setUsername($md5author)
                ->setRealname($username)
                ->setPassword($this->initPassword())
                ->setEmail($email)
                ->setRegdate($this->randTime())
                ->setRegip($this->randomip());
            $groupid = 0;
            $dm->setGroupid($groupid);
            $groupService = Wekit::load('usergroup.srv.PwUserGroupsService');
            $memberid = $groupService->calculateLevel(0);
            $dm->setMemberid($memberid);

            $result = Wekit::load('user.PwUser')->addUser($dm);
            if ($result instanceof PwError) {
				keydatas_failRsp(1405, "insert user to db error", "ûݿʧ");
            }
            //վͳϢ
            Wind::import('SRV:site.dm.PwBbsinfoDm');
            $bbsDm = new PwBbsinfoDm();
            $bbsDm->setNewmember($dm->getField('username'))->addTotalmember(1);
            Wekit::load('site.PwBbsinfo')->updateInfo($bbsDm);
            $uid = $dm->uid;
        } catch (\Exception $e) {
           keydatas_failRsp(1405, "insert user to db error", "ûݿʧ");
        }

        if ($uid) {
            $pwUserBelongDao = new PwUserBelongDao();
            $pwUserBelongDao->edit($uid, array(
                'gid' => 8
            ));

            $pwUserDataDao = new PwUserDataDao();
            $pwUserDataDao->editUser($uid, array(
                'credit1' => 10,
                'credit2' => 10
            ));
        }

        return array("uid" => $uid, "realname" => $username);
    }	
	

}

	
function keydatas_successRsp($data = "", $msg = "") {
    keydatas_rsp(1,0, $data, $msg);
}

function keydatas_failRsp($code = 0, $data = "", $msg = "") {
    keydatas_rsp(0,$code, $data, $msg);
}

function keydatas_rsp($result = 1,$code = 0, $data = "", $msg = "") {
	die(json_encode(array("rs" => $result, "code" => $code, "data" => $data, "msg" => urlencode($msg))));
}

function kdsVersion() {
    $reply = array(
        'protocol' => '1',
        'protocolVersion' => '1',
        'supportStdVersion' => array(
            'article' => '1.0.0',
            'bbscontent' => '1.0.0'
        ),
        'php' => PHP_VERSION,
        'supportVersion' => 'phpwind 9.X',
        'version' => '1.0.2',
        'pubVersion' => '1.0.2',
        'versionDetail' => array('wind_version' => WIND_VERSION), 
        'otherInfo' => array(),
        'versionDetail' => array('wekit_version' => WEKIT_VERSION, 'next_version' => NEXT_VERSION, 'next_release' => NEXT_RELEASE, 'next_fixbug' => NEXT_FIXBUG)
    );
    return $reply;
}