<?php
require_once 'util.php';
require_once 'KdsThreadDao.php';
Wind::import('SRV:forum.srv.PwPost');
Wind::import('SRV:forum.dao.PwForumStatisticsDao');
Wind::import('SRV:forum.dao.PwThreadsCateIndexDao');
Wind::import('SRV:forum.dao.PwThreadsIndexDao');
Wind::import('SRV:forum.dao.PwThreadsContentDao');
Wind::import('SRV:forum.dao.PwThreadsHitsDao');
Wind::import('SRV:forum.dao.PwThreadsDao');
Wind::import('SRV:forum.dao.PwPostsDao');
Wind::import('SRV:user.dao.PwUserDataDao');
Wind::import('SRV:forum.srv.PwForumMiscService');
//version 1.0.2

class keydatas_bbscontent extends keydatas_util {

    public $userModel;
    public $postData;
    public $config = array();
    public $threadDao = null;



    public function __construct($postData) {
        parent::__construct();

        $this->postData = $postData;
        $this->getConfigInfo($postData);

        return $this;
    }


    public function getConfigInfo($postData) {
        if (count($postData)) {
            foreach ($postData as $key => $item) {
                if (in_array($key, self::getConfigKeys())) {
                    $this->config[$key] = $item;
                }
            }
        }

        if (!isset($this->config['min_time'])|| !$this->config['min_time']) {
            $this->config['min_time'] = time() - 10000000;
        }

        if (!isset($this->config['default_forum']) || !$this->config['default_forum']) {
            $forums = $this->getFroums();
            foreach ($forums as $k => $v) {
                $this->config['default_forum'] = $v['value'];
                break;
            }
        }
    }


    public function insertThread($_REQ) {
		$fid = intval($_REQ['fid']);
        $tid = '';
        $price = 0;
        $typeid = 0;
        $sortid = 0;
        $isgroup = 0;
        $replycredit = 0;
        $displayorder = 0;
        $digest = 0;
        $special = 0;
        $uid = 0;
		$user = $this->userModel->getMember($_REQ['username']);
		$username = $_REQ['username'];
		$userid = $user['uid'];
		$created_username = $username;
		$created_userid = $userid;
		$subject = $_REQ['subject'];
		$content = $_REQ['content'];
		if(isset($_REQ['created_time'])&&intval($_REQ['created_time'])!=1){
			$created_time = $_REQ['created_time'];
		}else{
			$created_time = time();
		}
		//$created_time = isset($_REQ['created_time'])?isset($_REQ['created_time']):time();
		//$tags = $_REQ['tags'];
        try {
            $special = 'default';
            Wind::import('SRV:forum.srv.post.PwTopicPost');
            $postAction = new PwTopicPost($fid);
            $special && $postAction->setSpecial($special);
            $pwPost = new PwPost($postAction);
            $postDm = $pwPost->getDm();
            $postDm->setTitle($subject)
                ->setContent($content)
                ->setReplyNotice(0)
				//->setUsehtml(1)
				;
            $postDm->setAuthor($created_userid, $created_username, $this->randomip());
            $postDm->setCreatedTime($created_time);
            $postDm->addReplies(0);
            $postDm->setTopictype(0);
            $postDm->setDisabled(0);
			
            if (($result = $pwPost->execute($postDm)) !== true) {
                $data = $result->getData();
                $data && $this->addMessage($data, 'data');
                $error = $result->getError();
                if (count($error) && isset($error[0]) && strpos($error[0], 'post.content.length.more') !== false) {
                    keydatas_failRsp(1405, "Article content is too long", "文章发布失败，文章内容长度超长，请到到phpwind网站后台设置论坛内容长度");
					
                } else {
                    keydatas_failRsp(1405, "Insert into article error", "文章发布失败");
                }
            }
            $tid = $pwPost->getNewId();

            $this->threadDao = new KdsThreadDao();
            $this->threadDao->updateThread($tid, array(
                'disabled' => 0,
                'ischeck' => 1,
                'replies' => 0,
                'hit' => 0,
                'created_time' => $created_time,
                'created_username' => $created_username,
                'created_userid' => $created_userid,
                'lastpost_time' => $created_time,
                'lastpost_username' => $created_username,
                'lastpost_userid' => $created_userid
            ));

            $pwThreadsCateIndexDao = new PwThreadsCateIndexDao();
            $pwThreadsCateIndexDao->updateThread($tid, array(
                'disabled' => 0,
                'created_time' => $created_time,
                'lastpost_time' => $created_time
            ));

            $pwThreadsContentDao = new PwThreadsContentDao();
			
            $pwThreadsContentDao->updateThread($tid, array(
                'useubb' => 0,
                'usehtml' => 1,
				//'tags' => $tags,
				'ipfrom' => $this->randomip(),
            ));
		

            if ($view_num) {
                $pwThreadsHitsDao = new PwThreadsHitsDao();
                $pwThreadsHitsDao->add(array('tid' => $tid, 'hits' => $view_num));
            }

            $pwThreadsIndexDao = new PwThreadsIndexDao();
            $pwThreadsIndexDao->updateThread($tid, array(
                'disabled' => 0,
                'created_time' => $created_time,
                'lastpost_time' => $created_time
            ));

            $kdsForumStatistics = new PwForumStatisticsDao();
            $forumStatistic = $kdsForumStatistics->getForum($fid);

            $kdsForumStatistics->updateForum($fid, array(
                'todayposts' => $forumStatistic['todayposts'],
                'todaythreads' => $forumStatistic['todaythreads'],
                'article' => $forumStatistic['article']+1,
                'posts' => $forumStatistic['posts']+1,
                'threads' => $forumStatistic['threads']+1,
                'lastpost_time' => $created_time,
                'lastpost_username' => $created_username,
                'lastpost_tid' => $tid
            ));

            $pwUserDataDao = new PwUserDataDao();
            $userData = $pwUserDataDao->getUserByUid($uid);

            $pwUserDataDao->editUser($uid, array(
                'lastvisit' => $created_time,
                'lastactivetime' => $created_time,
                'lastpost' => $created_time,
                'postnum' => $userData['postnum'] + 1,
                'credit1' => $userData['credit1'] + 2,
                'credit2' => $userData['credit2'] + 4
            ));

            if ($this->isToday($dateline)) {
                $kdsForumStatistics->updateForum($fid, array(
                    'todaythreads' => $forumStatistic['todaythreads'] + 1,
                ));
                $pwUserDataDao->editUser($uid, array(
                    'todaypost' => $userData['todaypost'] + 1
                ));
            }
        } catch (\Exception $e) {
            //throw $e;
			return keydatas_failRsp(1501, "Insert data error", "插入数据失败，异常：".$e);
        }

        return $tid;
    }

    public function insertData() {
	 	$this->userModel = new keydatas_util();
		$_REQ = $this->postData;
		//检查标题		
		$subject  = isset($_REQ['subject']) ? addslashes($_REQ['subject']) : '';//标题	
		if (empty($subject)) {
			keydatas_failRsp(1404, "subject is empty", "标题不能为空");
		}
		//检查内容		
		$content  = isset($_REQ['content']) ? addslashes($_REQ['content']) : '';
		if (empty($content)) {
			keydatas_failRsp(1404, "content is empty", "内容不能为空");
		}
		
		//检查fid		
		$fid  = isset($_REQ['fid']) ? addslashes($_REQ['fid']) : '';
		if (empty($fid)) {
			keydatas_failRsp(1404, "fid is empty", "fid不能为空");
		}
		
		//检查用户名	
		$username  = isset($_REQ['username']) ? addslashes($_REQ['username']) : '';
		if (empty($username)) {
			keydatas_failRsp(1404, "username is empty", "用户名不能为空");
		}

        $tid = $this->insertThread($_REQ);
       
        $pwForum = new PwForum();
		$docFinalUrl= Wind::getComponent('request')->getBaseUrl(true) . "/read.php?tid=".$fid."&tid=".$tid;

		$this->downloadImages($_REQ);
		 if ($tid) {
			unset($_REQ);
		}
		try {
            Wekit::load('forum.srv.PwForumMiscService')->countAllForumStatistics();
        } catch (Exception $e) {
		
		}	
		keydatas_successRsp(array("url" => $docFinalUrl));
    }


	 /**
     * 获取文件完整路径
     * @return string
     */
	public function getFilePath(){

	
		$rootUrl=dirname(dirname(dirname(dirname(dirname(__FILE__)))));
		return $rootUrl.'/attachment';
	}
	
    /**
     * 查找文件夹，如不存在就创建并授权
     * @return string
     */
	public function createFolders($dir){ 
		return is_dir($dir) or ($this->createFolders(dirname($dir)) and mkdir($dir, 0777)); 
	}	
		
	public function  downloadImages($_REQ){	
	  try{
		$downloadFlag = isset($_REQ['__kds_download_imgs_flag']) ? $_REQ['__kds_download_imgs_flag'] : '';
		if (!empty($downloadFlag) && $downloadFlag== "true") {
			$docImgsStr = isset($_REQ['__kds_docImgs']) ? $_REQ['__kds_docImgs'] : '';
			
			if (!empty($docImgsStr)) {
				$docImgs = explode(',',$docImgsStr);
				if (is_array($docImgs)) {
					$uploadDir = $this->getFilePath();
					foreach ($docImgs as $imgUrl) {
						$urlItemArr = explode('/',$imgUrl);
						$itemLen=count($urlItemArr);
						if($itemLen>=3){
							
							$fileRelaPath=$urlItemArr[$itemLen-3].'/'.$urlItemArr[$itemLen-2];
							$imgName=$urlItemArr[$itemLen-1];
							$finalPath=$uploadDir. '/'.$fileRelaPath;
							if ($this->createFolders($finalPath)) {
								$file = $finalPath . '/' . $imgName;
								if(!file_exists($file)){
									$doc_image_data = file_get_contents($imgUrl);
									file_put_contents($file, $doc_image_data);
								}
							}
						}
					}
				}
			}				
		}
	 } catch (Exception $ex) {
		
	 }		
	}	
	
}
